<template>
  <BasicModal
    v-bind="$attrs"
    @register="register"
    :title="t('routes.corporation.addSubId')"
    @visible-change="handleVisibleChange"
    @ok="handleSubmit"
    @cancel="handleClose"
  >
    <div class="pt-2px pr-3px">
      <BasicForm @register="registerForm" :model="model" />
    </div>
  </BasicModal>
</template>
<script lang="ts">
  import { defineComponent, ref, nextTick } from 'vue';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, FormSchema, useForm } from '/@/components/Form/index';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { checkUserAddAble } from '/@/api/corporation/modal';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { roleLIstApi } from '/@/api/staff/list';

  const { t } = useI18n();
  const schemas: FormSchema[] = [
    {
      field: 'memoName',
      component: 'Input',
      label: t('common.fullName'),
      colProps: {
        span: 24,
      },
      componentProps: {
        maxLength: 25,
      },
    },
    {
      field: 'phone',
      component: 'Input',
      label: t('common.mobile'),
      rules: [
        {
          required: true,
          // @ts-ignore
          validator: async (rule, value) => {
            var reg_tel =
              /^(13[0-9]|14[01456879]|15[0-35-9]|16[2567]|17[0-8]|18[0-9]|19[0-35-9])\d{8}$/;
            // var reg = /\S+@\S+\.\S+/;
            if (!value) {
              /* eslint-disable-next-line */

              return Promise.reject(t('common.phone'));
            }
            if (!reg_tel.test(value)) {
              /* eslint-disable-next-line */
              return Promise.reject(t('common.phoneError'));
            }
            return Promise.resolve();
          },
          trigger: 'change',
        },
      ],
      colProps: {
        span: 24,
      },
    },
    {
      field: 'roleId',
      component: 'ApiRadioGroup',
      label: '角色',
      required: true,
      itemProps: {
        validateTrigger: 'blur',
      },
      // defaultValue: 8,
      componentProps: {
        api: roleLIstApi,
        labelField: 'roleName',
        valueField: 'roleId',
      },
    },
  ];
  export default defineComponent({
    components: { BasicModal, BasicForm },
    props: {
      userData: { type: Object },
    },
    emits: ['register', 'submit', 'tablelist'],
    setup(props, { emit }) {
      const modelRef = ref({});
      const { createMessage } = useMessage();
      const [
        registerForm,
        {
          // getFieldsValue,
          // setFieldsValue,
          // setProps
          resetFields,
          validate,
        },
      ] = useForm({
        labelWidth: 120,
        schemas,
        showActionButtonGroup: false,
        actionColOptions: {
          span: 24,
        },
      });
      let addListFunc = () => {};
      const [register, { closeModal }] = useModalInner((data) => {
        data && onDataReceive(data);
      });

      function onDataReceive(data) {
        console.log('Data Received', data);
      }
      const handleSubmit = async () => {
        const values = await validate();
        let addTips = false;
        emit('tablelist', (list) => {
          addTips = list.some((ele) => ele.userName == values.phone);
        });

        if (addTips) {
          return createMessage.error('员工账号已被绑定');
        }
        //TODO hack parameter
        let res = await checkUserAddAble({ phone: values.phone });
        console.log('checkUserAddAble', res);
        if (res.result == false) {
          // addListFunc({ phone: values.phone, memoName: values.memoName });
          emit('submit', {
            phone: values.phone,
            memoName: values.memoName,
            roleId: values.roleId,
          });
          resetFields();
          closeModal();
        } else {
          createMessage.error('员工账号已被绑定');
        }
      };
      function handleVisibleChange(v) {
        v && props.userData && nextTick(() => onDataReceive(props.userData));
      }
      function handleClose() {
        resetFields();
      }
      return {
        t,
        register,
        schemas,
        registerForm,
        model: modelRef,
        handleVisibleChange,
        handleSubmit,
        addListFunc,
        closeModal,
        handleClose,

        // nextTick,
      };
    },
  });
</script>
